      DOUBLE PRECISION FUNCTION F06BNF( A, B )
*     .. Scalar Arguments ..
      DOUBLE PRECISION                  A, B
*     ..
*
*     MARK 12 RELEASE. NAG COPYRIGHT 1986.
*
*     F06BNF returns the value
*
*        p = sqrt( a*a + b*b )
*
*     via the function name.
*
*
*     Nag Fortran 77 O( 1 ) basic linear algebra routine.
*
*  -- Written on 17-January-1985.
*     Sven Hammarling, Nag Central Office.
*
*     .. Parameters ..
      DOUBLE PRECISION                  ZERO
      PARAMETER                       ( ZERO = 0.0D+0 )
*     .. Local Scalars ..
      DOUBLE PRECISION                  P
*     .. Intrinsic Functions ..
      INTRINSIC                         ABS, SQRT
*     .. Executable Statements ..
      IF( A.EQ.ZERO )THEN
         P = ABS( B )
      ELSE IF( B.EQ.ZERO )THEN
         P = ABS( A )
      ELSE IF( ABS( A ).GE.ABS( B ) )THEN
         P = ABS( A )*SQRT( 1 + ( B/A )**2 )
      ELSE
         P = ABS( B )*SQRT( 1 + ( A/B )**2 )
      END IF
*
      F06BNF = P
      RETURN
*
*     End of F06BNF. ( SPYTH )
*
      END
