      SUBROUTINE X04CCFN(UPLO,DIAG,N,A,TITLE,ERRBUF,IFAIL)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     Prints a real triangular matrix stored in packed vector form.
C     Easy to use driver for X04CDFN.
C     .. Parameters ..
      CHARACTER*6        SRNAME
      PARAMETER          (SRNAME='X04CCF')
C     .. Scalar Arguments ..
      INTEGER            IFAIL, N
      CHARACTER          DIAG, UPLO
      CHARACTER*200      ERRBUF
      CHARACTER*(*)      TITLE
C     .. Array Arguments ..
      DOUBLE PRECISION   A(*)
C     .. Local Scalars ..
      INTEGER            IERR, IFCDF, NREC
C     .. Local Arrays ..
      CHARACTER          CLABS(1), RLABS(1)
      CHARACTER*80       REC(2)
C     .. External Functions ..
      INTEGER            P01ABFN
      EXTERNAL           P01ABFN
C     .. External Subroutines ..
      EXTERNAL           X04CDFN
C     .. Intrinsic Functions ..
      INTRINSIC          CHAR
C     .. Executable Statements ..
      CONTINUE
      ERRBUF(1:1) = CHAR(0)
C
C     Check for incorrect arguments.
C
      IERR = 0
      NREC = 0
C
      IF (UPLO.NE.'L' .AND. UPLO.NE.'l' .AND. UPLO.NE.'U' .AND. UPLO.NE.
     *    'u') THEN
         IERR = 1
         NREC = 1
         WRITE (REC,FMT=99999) UPLO
         WRITE (ERRBUF,FMT=19999) SRNAME, 1, 99999, 1, UPLO
      ELSE IF (DIAG.NE.'U' .AND. DIAG.NE.'u' .AND. DIAG.NE.'N' .AND.
     *         DIAG.NE.'n' .AND. DIAG.NE.'B' .AND. DIAG.NE.'b') THEN
         IERR = 2
         NREC = 1
         WRITE (REC,FMT=99998) DIAG
         WRITE (ERRBUF,FMT=19998) SRNAME, 2, 99998, 1, DIAG
      END IF
C
      IF (IERR.NE.0) GO TO 10
C
C     End of argument checking.
C
      IFCDF = 1
      CALL X04CDFN(UPLO,DIAG,N,A,' ',TITLE,'I',RLABS,'I',CLABS,80,0,
     *             ERRBUF,IFCDF)
C
   10 CONTINUE
      ERRBUF(200:200) = CHAR(0)
      IFAIL = P01ABFN(IFAIL,IERR,SRNAME,NREC,REC)
C
      RETURN
C
99999 FORMAT (' ** On entry, UPLO is not valid: UPLO = ''',A,'''.')
19999 FORMAT (A,3(1X,I5),1X,A)
99998 FORMAT (' ** On entry, DIAG is not valid: DIAG = ''',A,'''.')
19998 FORMAT (A,3(1X,I5),1X,A)
      END
