      SUBROUTINE X04CEFN(M,N,KL,KU,A,LDA,TITLE,ERRBUF,IFAIL)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     Prints a real banded matrix stored in packed form.
C     Easy to use driver for X04CFFN.
C     .. Parameters ..
      CHARACTER*6        SRNAME
      PARAMETER          (SRNAME='X04CEF')
C     .. Scalar Arguments ..
      INTEGER            IFAIL, KL, KU, LDA, M, N
      CHARACTER*200      ERRBUF
      CHARACTER*(*)      TITLE
C     .. Array Arguments ..
      DOUBLE PRECISION   A(LDA,*)
C     .. Local Scalars ..
      INTEGER            IERR, IFCFF, NREC
C     .. Local Arrays ..
      CHARACTER          CLABS(1), RLABS(1)
      CHARACTER*80       REC(2)
C     .. External Functions ..
      INTEGER            P01ABFN
      EXTERNAL           P01ABFN
C     .. External Subroutines ..
      EXTERNAL           X04CFFN
C     .. Intrinsic Functions ..
      INTRINSIC          CHAR
C     .. Executable Statements ..
      CONTINUE
      ERRBUF(1:1) = CHAR(0)
C
C     Check for incorrect arguments.
C
      IERR = 0
      NREC = 0
      IF (KL.LT.0) THEN
         IERR = 1
         NREC = 1
         WRITE (REC,FMT=99999) KL
         WRITE (ERRBUF,FMT=19999) SRNAME, 1, 99999, 1, KL
      ELSE IF (KU.LT.0) THEN
         IERR = 2
         NREC = 1
         WRITE (REC,FMT=99998) KU
         WRITE (ERRBUF,FMT=19998) SRNAME, 2, 99998, 1, KU
      ELSE IF (LDA.LT.KL+KU+1) THEN
         IERR = 3
         NREC = 2
         WRITE (REC,FMT=99997) LDA, KL, KU
         WRITE (ERRBUF,FMT=19997) SRNAME, 3, 99997, 3, LDA, KL, KU
      END IF
C
      IF (IERR.NE.0) GO TO 10
C
C     End of argument checking.
C
      IFCFF = 1
      CALL X04CFFN(M,N,KL,KU,A,LDA,' ',TITLE,'I',RLABS,'I',CLABS,80,0,
     *             ERRBUF,IFCFF)
C
   10 CONTINUE
      ERRBUF(200:200) = CHAR(0)
      IFAIL = P01ABFN(IFAIL,IERR,SRNAME,NREC,REC)
C
      RETURN
C
99999 FORMAT (' ** On entry, KL .lt. 0: KL =',I16,'.')
19999 FORMAT (A,3(1X,I5),1X,I16)
99998 FORMAT (' ** On entry, KU .lt. 0: KU =',I16,'.')
19998 FORMAT (A,3(1X,I5),1X,I16)
99997 FORMAT (' ** On entry, LDA .lt. KL+KU+1: LDA =',I16,',',/4X,
     *       'KL =',I16,', KU =',I16,'.')
19997 FORMAT (A,3(1X,I5),1X,I16,1X,I16,1X,I16)
      END
