      SUBROUTINE X04DAFN(MATRIX,DIAG,M,N,A,LDA,TITLE,NOUT,ERRBUF,IFAIL)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     Prints a general complex matrix.
C     Easy to use driver for X04DBFN.
C     .. Parameters ..
      CHARACTER*6        SRNAME
      PARAMETER          (SRNAME='X04DAF')
C     .. Scalar Arguments ..
      INTEGER            IFAIL, LDA, M, N, NOUT
      CHARACTER          DIAG, MATRIX
      CHARACTER*200      ERRBUF
      CHARACTER*(*)      TITLE
C     .. Array Arguments ..
      COMPLEX *16        A(LDA,*)
C     .. Local Scalars ..
      INTEGER            IERR, IFDBF, NREC
      LOGICAL            GENERL, LOWER, UPPER
C     .. Local Arrays ..
      CHARACTER          CLABS(1), RLABS(1)
      CHARACTER*80       REC(2)
C     .. External Functions ..
      INTEGER            P01ABFN
      EXTERNAL           P01ABFN
C     .. External Subroutines ..
      EXTERNAL           X04DBFN
C     .. Intrinsic Functions ..
      INTRINSIC          CHAR
C     .. Executable Statements ..
      CONTINUE
      ERRBUF(1:1) = CHAR(0)
C
      IERR = 0
      NREC = 0
      GENERL = MATRIX .EQ. 'G' .OR. MATRIX .EQ. 'g'
      LOWER = MATRIX .EQ. 'L' .OR. MATRIX .EQ. 'l'
      UPPER = MATRIX .EQ. 'U' .OR. MATRIX .EQ. 'u'
C
C     Check for incorrect arguments.
C
      IF ( .NOT. GENERL .AND. .NOT. LOWER .AND. .NOT. UPPER) THEN
         IERR = 1
         NREC = 1
         WRITE (REC,FMT=99999) MATRIX
         WRITE (ERRBUF,FMT=19999) SRNAME, 1, 99999, 1, MATRIX
      ELSE IF (M.GT.LDA) THEN
         IERR = 3
         NREC = 1
         WRITE (REC,FMT=99998) M, LDA
         WRITE (ERRBUF,FMT=19998) SRNAME, 3, 99998, 2, M, LDA
      ELSE IF ( .NOT. GENERL) THEN
         IF (DIAG.NE.'U' .AND. DIAG.NE.'u' .AND. DIAG.NE.'N' .AND.
     *       DIAG.NE.'n' .AND. DIAG.NE.'B' .AND. DIAG.NE.'b') THEN
            IERR = 2
            NREC = 1
            WRITE (REC,FMT=99997) MATRIX, DIAG
            WRITE (ERRBUF,FMT=19997) SRNAME, 2, 99997, 2, MATRIX, DIAG
         END IF
C
      END IF
C
      IF (IERR.NE.0) GO TO 10
C
C     End of argument checking.
C
      IFDBF = 0
      CALL X04DBFN(MATRIX,DIAG,M,N,A,LDA,'Above',' ',TITLE,'I',RLABS,
     *             'I',CLABS,80,0,NOUT,ERRBUF,IFDBF)
C
   10 CONTINUE
      ERRBUF(200:200) = CHAR(0)
      IFAIL = P01ABFN(IFAIL,IERR,SRNAME,NREC,REC)
C
      RETURN
C
99999 FORMAT (' ** On entry, MATRIX is not valid: MATRIX = ''',A,'''.')
19999 FORMAT (A,3(1X,I5),1X,A)
99998 FORMAT (' ** On entry, M .gt. LDA: M = ',I16,', LDA = ',I16,'.')
19998 FORMAT (A,3(1X,I5),1X,I16,1X,I16)
99997 FORMAT (' ** On entry, MATRIX = ''',A,''', but DIAG is not val',
     *       'id: DIAG = ''',A,'''.')
19997 FORMAT (A,3(1X,I5),1X,A,1X,A)
      END
