      SUBROUTINE X04DBFN(MATRIX,DIAG,M,N,A,LDA,USEFRM,FORM,TITLE,LABROW,
     *                   RLABS,LABCOL,CLABS,NCOLS,INDENT,NOUT,ERRBUF,
     *                   IFAIL)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     MARK 16A REVISED. IER-1049 (JUN 1993).
C     Prints a general complex matrix.
C     .. Parameters ..
      CHARACTER*6        SRNAME
      PARAMETER          (SRNAME='X04DBF')
      COMPLEX *16        CZERO
      PARAMETER          (CZERO=(0.0D+0,0.0D+0))
      DOUBLE PRECISION   FRNGLW, FRNGUP, ONE, ZERO
      PARAMETER          (FRNGLW=1.0D-3,FRNGUP=9.99999991D+3,ONE=1.0D+0,
     *                   ZERO=0.0D+0)
C     .. Scalar Arguments ..
      INTEGER            IFAIL, INDENT, LDA, M, N, NCOLS, NOUT
      CHARACTER          DIAG, LABCOL, LABROW, MATRIX, USEFRM
      CHARACTER*200      ERRBUF
      CHARACTER*(*)      FORM, TITLE
C     .. Array Arguments ..
      COMPLEX *16        A(LDA,*)
      CHARACTER*(*)      CLABS(*), RLABS(*)
C     .. Local Scalars ..
      COMPLEX *16        DIAGEL
      DOUBLE PRECISION   AA, BASE, LBASE, MAXEL, MINEL, RNDIGS
      INTEGER            CL, CLBWID, CLEFT, CRIGHT, CLSHFT, FINIS2,
     *                   FINISH, I, IERR, INCOLS, INDNT, J, K, LWID, ND,
     *                   NDIGS1, NDIGS2, NELEMS, NELS, NREC, NSETS,
     *                   NTITLE, NUMWID, OFFSET, RLBWID, START
      LOGICAL            ABOVE, BRACK, GENERL, LOWER, PRDIAG
      CHARACTER*10       ICFORM, IRFORM
      CHARACTER*81       FORMT
      CHARACTER*132      BLANKS, TILTER
      CHARACTER*133      INFBOT, INFILE
      CHARACTER*189      FMAT
      CHARACTER*266      INFIL2
C     .. Local Arrays ..
      CHARACTER*80       REC(2)
C     .. External Functions ..
      INTEGER            P01ABFN, X02BHFN, X02BJFN, X02BKFN, X02BLFN
      EXTERNAL           P01ABFN, X02BHFN, X02BJFN, X02BKFN, X02BLFN
C     .. External Subroutines ..
      EXTERNAL           X04BAFN, X04CBZN
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, CHAR, DBLE, DIMAG, LEN, LOG10, MAX, MIN
C     .. Executable Statements ..
      CONTINUE
      ERRBUF(1:1) = CHAR(0)
C
      IERR = 0
      GENERL = MATRIX .EQ. 'G' .OR. MATRIX .EQ. 'g'
      LOWER = MATRIX .EQ. 'L' .OR. MATRIX .EQ. 'l'
      ABOVE = USEFRM .EQ. 'A' .OR. USEFRM .EQ. 'a'
      BRACK = USEFRM .EQ. 'B' .OR. USEFRM .EQ. 'b'
      IF (NCOLS.LE.0 .OR. NCOLS.GT.132) THEN
         INCOLS = 80
      ELSE
         INCOLS = NCOLS
      END IF
      IF (INDENT.LT.0 .OR. INDENT.GE.INCOLS) THEN
         INDNT = 0
      ELSE
         INDNT = INDENT
      END IF
      INCOLS = INCOLS - INDNT
      BLANKS = ' '
C
C     Check for incorrect arguments.
      IF ( .NOT. GENERL .AND. .NOT. LOWER .AND. MATRIX.NE.'U' .AND.
     *    MATRIX.NE.'u') THEN
         IERR = 1
         NREC = 1
         WRITE (REC,FMT=99999) MATRIX
         WRITE (ERRBUF,FMT=19999) SRNAME, 1, 99999, 1, MATRIX
      ELSE IF ((LABROW.NE.'N' .AND. LABROW.NE.'n' .AND. LABROW.NE.
     *         'I' .AND. LABROW.NE.'i' .AND. LABROW.NE.'C' .AND.
     *         LABROW.NE.'c') .OR. (LABCOL.NE.'N' .AND. LABCOL.NE.
     *         'n' .AND. LABCOL.NE.'I' .AND. LABCOL.NE.'i' .AND.
     *         LABCOL.NE.'C' .AND. LABCOL.NE.'c')) THEN
         IERR = 7
         NREC = 2
         WRITE (REC,FMT=99996) LABROW, LABCOL
         WRITE (ERRBUF,FMT=19996) SRNAME, 7, 99996, 2, LABROW, LABCOL
      ELSE IF ( .NOT. ABOVE .AND. .NOT. BRACK .AND. USEFRM.NE.'D' .AND.
     *         USEFRM.NE.'d') THEN
         IERR = 4
         NREC = 1
         WRITE (REC,FMT=99995) USEFRM
         WRITE (ERRBUF,FMT=19995) SRNAME, 4, 99995, 1, USEFRM
      ELSE IF (M.GT.LDA) THEN
         IERR = 3
         NREC = 1
         WRITE (REC,FMT=99998) M, LDA
         WRITE (ERRBUF,FMT=19998) SRNAME, 3, 99998, 2, M, LDA
      ELSE IF ( .NOT. GENERL) THEN
         IF (DIAG.NE.'U' .AND. DIAG.NE.'u' .AND. DIAG.NE.'N' .AND.
     *       DIAG.NE.'n' .AND. DIAG.NE.'B' .AND. DIAG.NE.'b') THEN
            IERR = 2
            NREC = 1
            WRITE (REC,FMT=99997) MATRIX, DIAG
            WRITE (ERRBUF,FMT=19997) SRNAME, 2, 99997, 2, MATRIX, DIAG
         END IF
      END IF
      IF (IERR.NE.0) GO TO 580
C
C     End of argument checking.
C
C
      FORMT = FORM
      IF (FORMT.EQ.'*') THEN
C        Construct an E FORMAT that is wide enough to distinguish
C        between adjacent machine numbers.
         BASE = X02BHFN()
         LBASE = LOG10(BASE)
         RNDIGS = X02BJFN()*LBASE
         NDIGS1 = RNDIGS
         IF (NDIGS1.LT.RNDIGS) NDIGS1 = NDIGS1 + 1
C        NDIGS1 is the number of significant decimal digits required
C        for the mantissa.
         RNDIGS = LOG10(MAX(-X02BKFN(),X02BLFN())*LBASE) + 2
         NDIGS2 = RNDIGS
         IF (NDIGS2.LT.RNDIGS) NDIGS2 = NDIGS2 + 1
C        NDIGS2 is the number of decimal places required for the
C        exponent, including letter 'E' and sign.
         FORMT = '1P,E   .   '
         WRITE (FORMT(5:7),FMT='(I3)') NDIGS1 + NDIGS2 + 3
         WRITE (FORMT(9:11),FMT='(I3)') NDIGS1 - 1
      ELSE IF (FORMT.EQ.' ') THEN
C        Construct either a fixed point FORMAT, if the elements to be
C        printed are a reasonable size, i.e. all lie inside the range
C        0.001 to 9999.9999, or a floating-point FORMAT otherwise,
C        printing to 5 significant digits.
C        First find the largest and smallest elements to be printed,
C        ignoring zeros.
         MAXEL = ONE
         MINEL = ONE
         IF (GENERL) THEN
            DO 40 J = 1, N
               DO 20 I = 1, M
                  AA = MAX(ABS(DBLE(A(I,J))),ABS(DIMAG(A(I,J))))
                  IF (AA.GT.MAXEL) MAXEL = AA
                  IF (AA.NE.ZERO .AND. AA.LT.MINEL) MINEL = AA
   20          CONTINUE
   40       CONTINUE
         ELSE
            IF (DIAG.EQ.'N' .OR. DIAG.EQ.'n') THEN
               DO 60 J = 1, MIN(M,N)
                  AA = MAX(ABS(DBLE(A(J,J))),ABS(DIMAG(A(J,J))))
                  IF (AA.GT.MAXEL) MAXEL = AA
                  IF (AA.NE.ZERO .AND. AA.LT.MINEL) MINEL = AA
   60          CONTINUE
            END IF
            DO 120 J = 1, N
               IF (LOWER) THEN
                  DO 80 I = J + 1, M
                     AA = MAX(ABS(DBLE(A(I,J))),ABS(DIMAG(A(I,J))))
                     IF (AA.GT.MAXEL) MAXEL = AA
                     IF (AA.NE.ZERO .AND. AA.LT.MINEL) MINEL = AA
   80             CONTINUE
               ELSE
                  DO 100 I = 1, J - 1
                     AA = MAX(ABS(DBLE(A(I,J))),ABS(DIMAG(A(I,J))))
                     IF (AA.GT.MAXEL) MAXEL = AA
                     IF (AA.NE.ZERO .AND. AA.LT.MINEL) MINEL = AA
  100             CONTINUE
               END IF
  120       CONTINUE
         END IF
C
         IF (MINEL.GE.FRNGLW .AND. MAXEL.LT.FRNGUP) THEN
C           If all elements to be printed are moderately sized,
C           use a fixed point FORMAT ...
            IF (MAXEL.LE.ONE) THEN
               FORMT = 'F8.4'
            ELSE
               FORMT = 'F11.4'
            END IF
         ELSE
C           ... otherwise use a floating-point FORMAT.
            FORMT = '1PE13.4'
         END IF
      END IF
C
C     Construct the format statement to be used internally.
      CALL X04CBZN(FORMT,START,FINISH)
      IF (FINISH-START+1.GT.80) THEN
C        The length of FORM is too great.
         IERR = 5
         NREC = 2
         WRITE (REC,FMT=99994) FORM(START:START+74)
         WRITE (ERRBUF,FMT=19994) SRNAME, 5, 99994, 1,
     *     FORM(START:START+74)
         GO TO 580
      END IF
C
      IF (BRACK) THEN
C        Insert brackets and comma into the edit descriptor.
         FMAT = '(999(:,'' ('','//FORMT(START:FINISH)
     *          //','','','//FORMT(START:FINISH)//','')''))'
      ELSE
         FMAT = '(999(:,'//FORMT(START:FINISH)//'))'
      END IF
C
C     Decide how wide each column of numbers is going to be,
C     by writing the number ZERO to an internal file and measuring
C     the width needed. Since the width may include trailing blanks,
C     we also write ZERO twice with the same format, and compute
C     the required field width from the two widths. Note that if
C     FORM has more than one edit descriptors in it, with different
C     field widths, for example FORM = 'E12.3,E13.4', then it may
C     not be possible to compute a sensible value, in which case
C     the columns of the output matrix will be a little skew.
      IF (ABOVE) THEN
         WRITE (INFILE,FMT=FMAT,ERR=140) ZERO
         WRITE (INFIL2,FMT=FMAT,ERR=140) ZERO, ZERO
      ELSE
         WRITE (INFILE,FMT=FMAT,ERR=140) CZERO
         WRITE (INFIL2,FMT=FMAT,ERR=140) CZERO, CZERO
      END IF
      CALL X04CBZN(INFILE,START,FINISH)
      CALL X04CBZN(INFIL2,START,FINIS2)
      NUMWID = FINIS2 - FINISH
C     NUMWID is the width of a number as printed using FORMT.
      GO TO 160
  140 CONTINUE
C     The format in FMAT caused an error when used to print a number.
      IERR = 6
      NREC = 2
      WRITE (REC,FMT=99993) FORM(1:MIN(75,LEN(FORM)))
      WRITE (ERRBUF,FMT=19993) SRNAME, 6, 99993, 2,
     *  FORM(1:MIN(75,LEN(FORM)))
      GO TO 580
  160 CONTINUE
C
C     What kind of row labelling is required?
      IF (LABROW.EQ.'N' .OR. LABROW.EQ.'n') THEN
C        No row labelling.
         RLBWID = 1
      ELSE IF (LABROW.EQ.'I' .OR. LABROW.EQ.'i') THEN
C        Numeric row labelling.
         WRITE (INFILE,FMT='(I16)') M
         CALL X04CBZN(INFILE,START,FINISH)
         RLBWID = FINISH - START + 2
         IRFORM = '(I    )'
         WRITE (IRFORM(3:6),FMT='(I4)') RLBWID
      ELSE
C        User supplied row labelling.
         RLBWID = 1
         DO 180 I = 1, M
            CALL X04CBZN(RLABS(I),START,FINISH)
            RLBWID = MAX(RLBWID,FINISH-START+2)
  180    CONTINUE
      END IF
C
C     What kind of column labelling is required?
      IF (LABCOL.EQ.'I' .OR. LABCOL.EQ.'i') THEN
C        Numeric column labelling.
         WRITE (INFILE,FMT='(I16)') N
         CALL X04CBZN(INFILE,START,FINISH)
         CLBWID = FINISH - START + 2
         ICFORM = '(999I    )'
         WRITE (ICFORM(6:9),FMT='(I4)') NUMWID
      ELSE IF (LABCOL.NE.'N' .AND. LABCOL.NE.'n') THEN
C        User supplied column labelling.
         CLBWID = LEN(CLABS(1))
      END IF
C
      NELEMS = (INCOLS-1-RLBWID)/NUMWID
      IF (NELEMS.LT.1) THEN
         IERR = 8
         NREC = 2
         WRITE (REC,FMT=99992) INCOLS + INDNT, INDNT
         WRITE (ERRBUF,FMT=19992) SRNAME, 8, 99992, 2, INCOLS + INDNT,
     *     INDNT
         GO TO 580
      END IF
C     NELEMS is the number of elements that can fit into INCOLS columns.
C
      NSETS = (N-1)/NELEMS + 1
C     NSETS is the number of pieces that the matrix must be split into.
C
C     Print the title, splitting it up if more than INCOLS-1 characters.
      CALL X04CBZN(TITLE,START,FINISH)
      IF (FINISH.NE.0) THEN
         NTITLE = (FINISH-1)/(INCOLS-1) + 1
         DO 200 I = 1, NTITLE - 1
            TILTER = BLANKS(1:INDNT+1)//TITLE((I-1)*(INCOLS-1)
     *               +1:I*(INCOLS-1))
            CALL X04BAFN(NOUT,TILTER)
  200    CONTINUE
         TILTER = BLANKS(1:INDNT+1)//TITLE((NTITLE-1)*(INCOLS-1)
     *            +1:FINISH)
         CALL X04BAFN(NOUT,TILTER)
      END IF
C
C     Exit after printing the title if M or N is less than 1.
      IF (M.LT.1 .OR. N.LT.1) GO TO 580
C
C     Print the matrix, with row and column labels if requested.
      CLSHFT = 0
C     CLSHFT is the offset into the current set of columns, when
C     the matrix cannot be printed in one go but has to be split.
      DO 560 I = 1, NSETS
         IF (I.EQ.NSETS) THEN
            NELS = N - (NSETS-1)*NELEMS
         ELSE
            NELS = NELEMS
         END IF
         IF (LABCOL.EQ.'I' .OR. LABCOL.EQ.'i') THEN
C           Construct the numeric column labels.
            INFILE = ' '
            WRITE (INFILE(RLBWID+2+INDNT:),FMT=ICFORM) (CL,CL=CLSHFT+1,
     *        CLSHFT+NELS)
         ELSE IF (LABCOL.NE.'N' .AND. LABCOL.NE.'n') THEN
C           Process the user-supplied column labels.
            INFILE = ' '
            LWID = MIN(CLBWID,NUMWID)
            OFFSET = RLBWID + 1 + INDNT
            DO 220 K = CLSHFT + 1, CLSHFT + NELS
               CALL X04CBZN(CLABS(K)(1:LWID),START,FINISH)
               IF (START.EQ.0) THEN
                  START = 1
                  FINISH = 1
               END IF
               INFILE(OFFSET+NUMWID-FINISH+START:
     *           OFFSET+NUMWID+FINISH-START) = CLABS(K) (START:FINISH)
               OFFSET = OFFSET + NUMWID
  220       CONTINUE
         END IF
C        Output the column labels.
         IF (LABCOL.NE.'N' .AND. LABCOL.NE.'n') THEN
            CALL X04BAFN(NOUT,INFILE(1:NCOLS))
         END IF
C
C        Now print each row in turn.
         DO 540 J = 1, M
            INFILE = ' '
C
C           Insert the row label.
            IF (LABROW.EQ.'I' .OR. LABROW.EQ.'i') THEN
               WRITE (INFILE(INDNT+1:INDNT+RLBWID),FMT=IRFORM) J
            ELSE IF (LABROW.NE.'N' .AND. LABROW.NE.'n') THEN
               CALL X04CBZN(RLABS(J),START,FINISH)
               IF (START.EQ.0) THEN
                  START = 1
                  FINISH = 1
               END IF
               INFILE(INDNT+RLBWID-FINISH+START:INDNT+RLBWID) = RLABS(J)
     *           (START:FINISH)
            END IF
C
            IF (GENERL) THEN
C              General rectangular matrix.
               IF (ABOVE) THEN
                  WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,ERR=240)
     *              (DBLE(A(J,CL)),CL=CLSHFT+1,CLSHFT+NELS)
  240             CONTINUE
                  INFBOT(1:INDNT+RLBWID+1) = ' '
                  WRITE (INFBOT(INDNT+RLBWID+2:),FMT=FMAT,ERR=260)
     *              (DIMAG(A(J,CL)),CL=CLSHFT+1,CLSHFT+NELS)
  260             CONTINUE
               ELSE
                  WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,ERR=280)
     *              (A(J,CL),CL=CLSHFT+1,CLSHFT+NELS)
  280             CONTINUE
               END IF
            ELSE
C              Upper or lower triangular matrix.
               ND = MAX(0,J-(I-1)*NELEMS)
C              ND is the position of the Jth row diagonal element.
               IF (LOWER) THEN
                  CLEFT = CLSHFT + 1
                  CRIGHT = CLSHFT + MIN(ND-1,NELS)
               ELSE
                  CLEFT = CLSHFT + ND + 1
                  CRIGHT = CLSHFT + NELS
               END IF
C              CLEFT and CRIGHT are the leftmost and rightmost elements
C              of the current row to be printed, excluding the diagonal.
               PRDIAG = DIAG .NE. 'B' .AND. DIAG .NE. 'b' .AND. ND .GT.
     *                  0 .AND. ND .LE. NELS
C              PRDIAG is true if a diagonal element appears in the
C              current matrix row section, and it is to be printed.
               IF (PRDIAG) THEN
                  IF (DIAG.EQ.'U' .OR. DIAG.EQ.'u') THEN
                     DIAGEL = ONE
                  ELSE
                     DIAGEL = A(J,J)
                  END IF
               END IF
C
               IF (LOWER) THEN
C                 Lower triangular matrix.
                  IF (PRDIAG) THEN
                     IF (ABOVE) THEN
                        IF (CLEFT.LE.CRIGHT) THEN
C                          Optimization bug on Alpha forces us to check
C                          CLEFT.LE.CRIGHT; DIAGEL didn't get printed
C                          out when CLEFT.GT.CRIGHT.
                           WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=300) (DBLE(A(J,CL)),CL=CLEFT,CRIGHT),
     *                       DBLE(DIAGEL)
                        ELSE
                           WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=300) DBLE(DIAGEL)
                        END IF
  300                   CONTINUE
                        INFBOT(1:INDNT+RLBWID+1) = ' '
                        IF (CLEFT.LE.CRIGHT) THEN
                           WRITE (INFBOT(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=320) (DIMAG(A(J,CL)),CL=CLEFT,CRIGHT),
     *                       DIMAG(DIAGEL)
                        ELSE
                           WRITE (INFBOT(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=320) DIMAG(DIAGEL)
                        END IF
  320                   CONTINUE
                     ELSE
                        IF (CLEFT.LE.CRIGHT) THEN
                           WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=340) (A(J,CL),CL=CLEFT,CRIGHT), DIAGEL
                        ELSE
                           WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,
     *                       ERR=340) DIAGEL
                        END IF
  340                   CONTINUE
                     END IF
                  ELSE
                     IF (ABOVE) THEN
                        WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,ERR=360)
     *                    (DBLE(A(J,CL)),CL=CLEFT,CRIGHT)
  360                   CONTINUE
                        INFBOT(1:INDNT+RLBWID+1) = ' '
                        WRITE (INFBOT(INDNT+RLBWID+2:),FMT=FMAT,ERR=380)
     *                    (DIMAG(A(J,CL)),CL=CLEFT,CRIGHT)
  380                   CONTINUE
                     ELSE
                        WRITE (INFILE(INDNT+RLBWID+2:),FMT=FMAT,ERR=400)
     *                    (A(J,CL),CL=CLEFT,CRIGHT)
  400                   CONTINUE
                     END IF
                  END IF
               ELSE
C                 Upper triangular matrix.
                  IF (PRDIAG) THEN
                     IF (ABOVE) THEN
                        WRITE (INFILE(INDNT+RLBWID+2+NUMWID*(ND-1):),
     *                    FMT=FMAT,ERR=420) DBLE(DIAGEL),
     *                    (DBLE(A(J,CL)),CL=CLEFT,CRIGHT)
  420                   CONTINUE
                        INFBOT = ' '
                        WRITE (INFBOT(INDNT+RLBWID+2+NUMWID*(ND-1):),
     *                    FMT=FMAT,ERR=440) DIMAG(DIAGEL),
     *                    (DIMAG(A(J,CL)),CL=CLEFT,CRIGHT)
  440                   CONTINUE
                     ELSE
                        WRITE (INFILE(INDNT+RLBWID+2+NUMWID*(ND-1):),
     *                    FMT=FMAT,ERR=460) DIAGEL,
     *                    (A(J,CL),CL=CLEFT,CRIGHT)
  460                   CONTINUE
                     END IF
                  ELSE
                     IF (CLEFT.LE.CRIGHT) THEN
C                       Have to do the check on CLEFT and CRIGHT to
C                       avoid INDNT+RLBWID+2+NUMWID*ND possibly being
C                       out of range.
                        IF (ABOVE) THEN
                           WRITE (INFILE(INDNT+RLBWID+2+NUMWID*ND:),
     *                       FMT=FMAT,ERR=480) (DBLE(A(J,CL)),CL=CLEFT,
     *                       CRIGHT)
  480                      CONTINUE
                           INFBOT = ' '
                           WRITE (INFBOT(INDNT+RLBWID+2+NUMWID*ND:),
     *                       FMT=FMAT,ERR=500) (DIMAG(A(J,CL)),CL=CLEFT,
     *                       CRIGHT)
  500                      CONTINUE
                        ELSE
                           WRITE (INFILE(INDNT+RLBWID+2+NUMWID*ND:),
     *                       FMT=FMAT,ERR=520) (A(J,CL),CL=CLEFT,CRIGHT)
  520                      CONTINUE
                        END IF
                     END IF
                  END IF
               END IF
            END IF
C
C           Output the (partial) matrix row.
            CALL X04BAFN(NOUT,INFILE(1:NCOLS))
            IF (ABOVE) THEN
               CALL X04BAFN(NOUT,INFBOT(1:NCOLS))
               IF (J.LT.M) CALL X04BAFN(NOUT,' ')
            END IF
C
  540    CONTINUE
C
         CLSHFT = CLSHFT + NELEMS
         IF (I.NE.NSETS) THEN
            CALL X04BAFN(NOUT,' ')
         END IF
  560 CONTINUE
C
  580 CONTINUE
      ERRBUF(200:200) = CHAR(0)
      IFAIL = P01ABFN(IFAIL,IERR,SRNAME,NREC,REC)
C
      RETURN
C
99999 FORMAT (' ** On entry, MATRIX is not valid: MATRIX = ''',A,'''.')
19999 FORMAT (A,3(1X,I5),1X,A)
99998 FORMAT (' ** On entry, M .gt .LDA: M = ',I16,', LDA = ',I16,'.')
19998 FORMAT (A,3(1X,I5),1X,I16,1X,I16)
99997 FORMAT (' ** On entry, MATRIX = ''',A,''', but DIAG is not val',
     *       'id: DIAG = ''',A,'''.')
19997 FORMAT (A,3(1X,I5),1X,A,1X,A)
99996 FORMAT (' ** On entry, either LABROW or LABCOL is not valid',/4X,
     *       'LABROW = ''',A,''', LABCOL = ''',A,'''.')
19996 FORMAT (A,3(1X,I5),1X,A,1X,A)
99995 FORMAT (' ** On entry, invalid USEFRM: USEFRM = ''',A,'''.')
19995 FORMAT (A,3(1X,I5),1X,A)
99994 FORMAT (' ** On entry, FORM has more than 80 characters: the',
     *       ' first 75 are',/4X,A,'.')
19994 FORMAT (A,3(1X,I5),1X,A)
99993 FORMAT (' ** The format specifier in FORM cannot be used to ',
     *       'print a number: FORM =',/4X,A,'.')
19993 FORMAT (A,3(1X,I5),1X,A)
99992 FORMAT (' ** On entry, NCOLS-INDENT is not wide enough to hold',
     *       ' at least one matrix',/4X,'column: NCOLS = ',I16,', INDE',
     *       'NT =',I16,'.')
19992 FORMAT (A,3(1X,I5),1X,I16,1X,I16)
      END
